POJ 2677(双调旅行商问题<bictonicTSP>

Tour

Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 3470 Accepted: 1545

Description

John Doe, a skilled pilot, enjoys traveling. While on vacation, he rents a small plane and starts visiting beautiful places. To save money, John must determine the shortest closed tour that connects
his destinations. Each destination is represented by a point in the plane pi = < xi,yi >. John uses the following strategy: he starts from the leftmost point, then he goes strictly left to right to the rightmost point, and then he goes strictly right back
to the starting point. It is known that the points have distinct x-coordinates.

Write a program that, given a set of n points in the plane, computes the shortest closed tour that connects the points according to John‘s strategy.

Input

The program input is from a text file. Each data set in the file stands for a particular set of points. For each set of points the data set contains the number of points, and the point coordinates in
ascending order of the x coordinate. White spaces can occur freely in input. The input data are correct.

Output

For each set of data, your program should print the result to the standard output from the beginning of a line. The tour length, a floating-point number with two fractional digits, represents the result.
An input/output sample is in the table below. Here there are two data sets. The first one contains 3 points specified by their x and y coordinates. The second point, for example, has the x coordinate 2, and the y coordinate 3. The result for each data set
is the tour length, (6.47 for the first data set in the given example).

Sample Input

3
1 1
2 3
3 1
4
1 1
2 3
3 1
4 2

Sample Output

6.47
7.89

#include<iostream>
#include<cmath>
#include<algorithm>
#include<cstdio>
#define INF 0x3f3f3f3f
const int maxn=10001;
using namespace std;

double dp[maxn][maxn],dis[maxn][maxn];
int n;

struct Point{
    int x;
    int y;
}p[maxn];

bool cmp(Point a,Point b)
{
    return a.x<b.x;
}

double cal(Point a,Point b)
{
    return sqrt((double)(a.x-b.x)*(a.x-b.x)+(double)(a.y-b.y)*(a.y-b.y));
}

double bitonicTSP()
{
    int i,j;
    dp[0][0]=0;
    dp[1][0]=dis[0][1];        //initial  dis[0][1]不是dis[1][0]

    for(i=1;i<n-1;i++)
    {
        dp[i+1][i]=INF;
        for(j=0;j<i;j++)
        {
            dp[i+1][j]=dp[i][j]+dis[i][i+1];
            dp[i+1][i]=min(dp[i+1][i],dp[i][j]+dis[j][i+1]);

        }
    }

    return dp[n-1][n-2]+dis[n-2][n-1];
}

int main()
{
    while(scanf("%d",&n)!=EOF)
    {
        scanf("%d%d",&p[0].x,&p[0].y);
        if(n==1) {printf("0.00\n");continue;}

        for(int i=1;i<n;i++)
        {
            scanf("%d%d",&p[i].x,&p[i].y);
        }

        sort(p,p+n,cmp);
        for(int i=0;i<n-1;i++)
            for(int j=i+1;j<n;j++)
            {
                dis[i][j]=cal(p[i],p[j]);          //注意这里,我的代码,要求dis[i][j],i<j,
            }

        printf("%.2lf\n",bitonicTSP());

    }
    return 0;

}

(表示确实很难理解!

具体思想,欢迎大家看:http://blog.csdn.net/code_or_code/article/details/26283159



POJ 2677(双调旅行商问题<bictonicTSP>

时间: 2024-10-13 14:43:12

POJ 2677(双调旅行商问题<bictonicTSP>的相关文章

POJ 2677 旅行商问题 双调dp或者费用流

Tour Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 3408   Accepted: 1513 Description John Doe, a skilled pilot, enjoys traveling. While on vacation, he rents a small plane and starts visiting beautiful places. To save money, John must

[ACM] POJ 2677 Tour (动态规划,双调欧几里得旅行商问题)

Tour Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 3585   Accepted: 1597 Description John Doe, a skilled pilot, enjoys traveling. While on vacation, he rents a small plane and starts visiting beautiful places. To save money, John must

POJ 2677 Tour 双调旅行商 dp, double+费用流

题目链接:点击打开链接 题意:给定二维平面上的n个点 从最左端点到最右端点(只能向右移动) 再返回到到最右端点(只能向左移动,且走过的点不能再走) 问最短路. 费用流: 为了达到遍历每个点的效果 把i点拆成 i && i+n 在i ->i+n 建一条费用为 -inf 的边,流量为1 这样跑最短路时必然会经过这条边,以此达到遍历的效果. dp :点击打开链接 对于i点 :只能跟一个点相连 -- 1.跟 i-1点相连 2.不跟i-1相连 用dp[i][j] 表示两个线头为 i 和 j 的

HDU 4824 双调旅行商问题

由于跳转一次需要400,大于在扇道内转一圈,所以应尽可能少的跳转扇道,就转换成了双调旅行商问题, 即从0区开始访问到最大的区域,再返回0区,所有中间点需走到一次 #include "stdio.h" #include "string.h" #include "math.h" #include "algorithm" using namespace std; struct node { int x,y; }a[1010]; in

UVA 1347(POJ 2677)Tour(双调欧几里得旅行商问题)

Tour                 Time Limit:3000MS    Memory Limit:0KB    64bit IO Format:%lld & %llu Description John Doe, a skilled pilot, enjoys traveling. While on vacation, he rents a small plane and starts visiting beautiful places. To save money, John mus

UVA 1347(POJ 2677) Tour(双色欧几里德旅行商问题)

Description John Doe, a skilled pilot, enjoys traveling. While on vacation, he rents a small plane and starts visiting beautiful places. To save money, John must determine the shortest closed tour that connects his destinations. Each destination is r

poj 2677 Tour

Tour Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 4556   Accepted: 1993 Description John Doe, a skilled pilot, enjoys traveling. While on vacation, he rents a small plane and starts visiting beautiful places. To save money, John must

百度之星资格赛——Disk Schedule(双调旅行商问题)

Disk Schedule Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2368    Accepted Submission(s): 333 Problem Description 有非常多从磁盘读取数据的需求,包含顺序读取.随机读取.为了提高效率,须要人为安排磁盘读取.然而.在现实中,这样的做法非常复杂. 我们考虑一个相对简单的

POJ 2677 Tour DP

双调欧几里得问题,复习一下.. 把所有的点按照x排序,设计状态f(i,j)表示走在前面的那个走到了i点,后面那个在j点,所需的最小,那么转移显而易见. f(i,j) = min(f(i - 1,j) + dist(i,i - 1), f(i,i - 1) + dist(i,j)) 直接顺着推过去可能好理解一些.. 当前状态f(i,j) 如果由i走到i + 1,那么就是f(i + 1,j),否则就是f(i + 1,i).. #include <cstdio> #include <cstri